## lockdev 1.0.0

=== Makefile ===
# this include do nothing if not run as a sub-make of debian/rules
-include debian/policy


libname	= liblockdev

objs	= src/lockdev.o


VER	= $(shell expr `pwd` : '.*-\([0-9.]*\)')
MVER	= ${shell expr `pwd` : '.*-\([0-9]*\).[0-9]*'}

static	= ${libname}.a
shared	= ${libname}.${VER}.so
soname	= ${libname}.so.${MVER}

# overwritten by caller (e.g.: debian/rules)
basedir	= /usr/local
srcdir=.

libdir	= ${basedir}/lib
incdir	= ${basedir}/include
mandir	= ${basedir}/share/man

CC	= gcc
LCFLAGS	= -g -O2 -fPIC -Wall -pipe -D_REENTRANT 
CFLAGS	= -g
LDLIBS	= -llockdev

.PHONY: shared static perl-lib
ALL:	shared static perl-lib

static ${static}:       ${objs}
	$(AR) $(ARFLAGS) ${static} $^

shared ${shared}:	${objs}
	${CC} ${LCFLAGS} -shared -Wl,-soname,${soname} $^ -lc -o ${shared}


perl-lib:	static
	cd LockDev && perl Makefile.PL INSTALLDIRS=perl
	cd LockDev && make
	cd LockDev && make test

.PHONY: install install_dev install_dbg install_doc install_run 
install:	install_dev install_dbg install_doc install_run

install_dev:	${static} src/lockdev.h
	install -m755 -d	${libdir}
	install -m644 ${static}	${libdir}
	install -m755 -d	${incdir}
	install -m644 src/lockdev.h	${incdir}
	install -m644 src/ttylock.h	${incdir}

install_debug:	${static} ${shared}
	install -m755 -d	${libdir}/debug
	install -m644 ${static}	${libdir}/debug
	install -m644 ${shared}	${libdir}/debug/${soname}

install_profile:	${static} ${shared}
	install -m755 -d	${libdir}/profile
	install -m644 ${static}	${libdir}/profile
	install -m644 ${shared}	${libdir}/profile/${soname}

install_doc:	docs/lockdev.3
	install -m755 -d	${mandir}/man3
	install -m644 docs/lockdev.3	${mandir}/man3

install_run:	${shared}
	install -m755 -d	${libdir}
	install -m644 ${shared}	${libdir}

.PHONY: clean distclean perl-clean mostyclean 
perl-clean:	clean
	cd LockDev && rm -rf *~ *.o LockDev.bs LockDev.c \
		Makefile Makefile.old blib pm_to_blib 

clean:
	-find . -name '*~' | xargs --no-run-if-empty  rm -f 
	-find . -name '*.o' | xargs --no-run-if-empty  rm -f 

mostyclean:	clean
	-rm -f *.a *.so *.so.*
	-rm -f shared static debug profile _SRCDIR_

distclean:	mostyclean perl-clean

.PHONY: distribute debian tarball
distribute:	debian tarball
debian:
	dpkg-buildpackage -rfakeroot 2>&1 | tee ../log.${VER}
tarball:
	${MAKE} -f debian/rules clean
	cd .. 	&& tar -cvf - ${libname}-${VER} | gzip -9c > ${libname}_${VER}.tgz

=== debian/changelog ===
lockdev (1.0.0) unstable; urgency=low

  * added management of pseudo device /dev/tty , thanx to Alan Cox.
  * added unconditional malloc of supplied device argoment.
  * changed name of the shared lib to end in .so
  * changed Makefile.PL because the perl manpage disappeared.
  * Changed symbols in the API as suggested by Daniel Quinlan and 
    Erik Troan. Changed soname accordingly.
  * Corrected manpages and added LSB proposal (draft 2).
  * corrected cua device management: use linux/major.h to determine the
    cua major number; conditioned to __linux__
  * Changed LICENSE file to hold the LGPL 2.1

 -- Fabrizio Polacco <fpolacco@debian.org>  Wed,  1 Dec 1999 12:59:10 +0200

lockdev (0.11.1) unstable; urgency=low

  * NMU for the perl upgrade. Closes: #41522
  * Corrected the rules files to conform to perl policy 1.0.1.
  * Compiled with perl-5.005.
  * Corrected the location of the license.
  * Upgraded standards-version to 2.5.1

 -- Raphael Hertzog <rhertzog@hrnet.fr>  Mon, 19 Jul 1999 20:51:00 +0200

lockdev (0.11) unstable; urgency=low

  * Avoided repetute locking of the semaphore.
  * Corrected special case of semaphore misbehaviour (found while
    crosschecking between two instancies running under gdb).
  * Added modification on-the-fly of major number of device from 4 to 5
    in case it was referring to one of the 64 cua devices; it now locks
    the major+minor numbers of the corresponding ttyS device. The name
    remains unaffected, as it could be an arbitrary name.
    (Thanx to Daniel Quinlan <quinlan@transmeta.com>)
  * Tryed to use fcntl instead of flock, after suggestion of Daniel
    Quinlan, to permit use on NFS mounted partitions.
    I wasn't able to make it correctly work, so I conditioned the
    changes and left the code there, for further (future)
    investigations. Any help highly appreciated.
  * changed third file (LCK..<pid>) to have three dots, and made it stay
    there, as a quick reference. It doesn't hurt, and shouw the pid with
    a simple ls -l
  * Added full text of LGPL licence instead of GPL one added in the
    previous version (oops).

 -- Fabrizio Polacco <fpolacco@debian.org>  Wed,  2 Jun 1999 15:58:03 +0300

lockdev (0.10) unstable; urgency=low

  * Added ttylock.h as Compatibility API to AIX. Programs written for
    that environment can be linked directly to lockdev library.
    (On AIX the symbols are in libc, so special care should be used)
  * changed location of manpages to /usr/share/man.
  * changed the name of the source to lockdev_0.10.tar.gz
  * changed address of FSF in Copyright file, added the full GPL text as
    LICENSE (only in the source), corrected name of the mailing list.
  * changed name of changelog, just to make lintian happier.
  * corrected name of docs dir for perl package.

 -- Fabrizio Polacco <fpolacco@debian.org>  Thu,  8 Apr 1999 21:04:53 +0300

liblockdev (0.9a) frozen unstable; urgency=low

  * Added more tests in postinst of liblockdev0g-dbg, to avoid strange
    problems encountered by Adam P. Harris (closes: #22565)

 -- Fabrizio Polacco <fpolacco@debian.org>  Mon, 18 May 1998 15:21:12 +0300

liblockdev (0.9) frozen unstable; urgency=low

  * cleaned symlinks in docs dirs.
  * changed libs symlinks from /usr/lib to /lib
  * stripped main shared library.
  * Corrected wrong shlibs dependency (thanx to Hamish Moffatt, 
    closes: #22282).
  * Changed dependency of -dev from libc6 to libc6-dev, 
    thanx to James Troup (closes: #16476).
  * Added -I.. in Makefile.PL to allow compilation of the perl part even
    when the -dev package isn't installed (thanx to Martin Schulze for
    the patch) closes: #15834

 -- Fabrizio Polacco <fpolacco@debian.org>  Tue, 12 May 1998 13:39:27 +0300

liblockdev (0.8) unstable; urgency=low

  * updated manpage (degugging section).
  * added environment variable to set debug value, and signals 
    to change those values at runtime (if compiled with -DDEBUG).
  * avoided symlink to /usr/src changing .stab in asm source 
    file (overwritten implicit rule to produce asm source).
    Thanx to Martin Schulze <joey> for the help.
  * changed dbg package to install shared debug lib in 
    /usr/lib/debug and profile lib in /usr/lib/profile.
  * splitted debian/rules in included debian/policy
  * cleaned Makefile and changed to build debug shared lib.
    Thanx to Yann Dirson.
  * added change in umask value to allow full permissions to lock 
    files.  (this is questionable: would it be better to add a 
    suid program to check and remove dangling locks?)

 -- Fabrizio Polacco <fpolacco@debian.org>  Tue, 23 Dec 1997 11:26:10 +0200

liblockdev (0.7) unstable; urgency=low

  * cleaned Makefile and debian/rules
  * change in Makefile.PL to allow pristine compilation on new systems
    (closes: #15834, thanx to Martin Schulze).
  * added -dbg package with debug and profile libs.
  * problem with lenght of dev_t in glibc for printf: cast needed :-)
  * corrected ftp address in copyright file.

 -- Fabrizio Polacco <fpolacco@debian.org>  Sun, 30 Nov 1997 01:00:50 +0200

liblockdev (0.6) unstable; urgency=low

  * added symlink to dirs in /usr/doc (one dir for all packages),
     now /usr/doc/liblockdev is a symlink installed by -dev package,
     as the liblockdev.a and liblockdev.so symlinks.
     Instead, lblockdev-perl installs a copy of the docs because
     it doesn't depend on the run-time binary package (as -dev does).
  * cleaned spreading in the distribution: 
     source and run-time to section 'libs', development into 'devel',
     perl module into 'interpreters' (waiting for a perl section).
  * created extension perl library LockDev:: with manpage LockDev(3pm)
     and packaged as liblockdev0-perl.
  * moved symlink so.0 -> so.0.6 to runtime package.
  * added unlink of semaphore file (not really needed, just to clean up)
  * corrected error in Synopsis of manpage (oops).
  * cleaned source code: changed ANSI-C definition of functions to K&R,


=== debian/control ===
Source: lockdev
Section: libs
Priority: optional
Maintainer: Fabrizio Polacco <fpolacco@debian.org>
Standards-Version: 3.1.0

Package: liblockdev1
Section: libs
Architecture: any
Depends: ${shlibs:Depends}
Description: Run-time shared library (libc6) for locking devices.
 It provides a reliable way to put an exclusive lock to
 devices using _both_ FSSTND and SVr4 methods.

Package: liblockdev1-dev
Section: devel
Architecture: any
Depends: liblockdev1 (=${Source-Version}), libc6-dev
Conflicts: liblockdev0-dev, liblockdev0g-dev 
Replaces: liblockdev0-dev, liblockdev0g-dev
Description: Development library (libc6) for locking devices.
 It provides a reliable way to put an exclusive lock to
 devices using _both_ FSSTND and SVr4 methods.
 .
 Includes header files and static lib.

Package: liblockdev1-dbg
Section: devel
Architecture: any
Depends: liblockdev1 (=${Source-Version}), liblockdev1-dev (=${Source-Version})
Conflicts: liblockdev0-dbg, liblockdev0g-dbg 
Replaces: liblockdev0-dbg, liblockdev0g-dbg
Description: Debugging library (libc6) for locking devices.
 It provides a reliable way to put an exclusive lock to
 devices using _both_ FSSTND and SVr4 methods.
 .
 Includes static and shared debugging and profiling libs,
 as well as the sources ready for use by gdb.

Package: liblockdev1-perl
Section: interpreters
Architecture: any
Depends: ${perl:Depends} 
Conflicts: liblockdev0-perl
Replaces:  liblockdev0-perl
Description: perl extension library for locking devices.
 It provides a reliable way to put an exclusive lock to
 devices using _both_ FSSTND and SVr4 methods.
 .
 Includes a shared lib loadable by perl 5 (use LockDev),
 the module LockDev.pm and its manpage LockDev(3pm) .

=== debian/rules ===
#!/usr/bin/make -f
# makefile to build a shared library as a debian binary package
# modifyed to handle alternate libc

libname=liblockdev
package=${libname}${version_major}

_debian_policy_ = 1
-include debian/policy

ifndef PERL
PERL = /usr/bin/perl 
endif

archlib = `$(PERL) -MConfig -e 'print $$Config{installarchlib}'`
config  = INSTALLDIRS=perl
config += INSTALLMAN1DIR=${d_man}/man1
config += INSTALLMAN3DIR=${d_man}/man3
config += INSTALLPRIVLIB=${d_ulib}/perl5
config += INSTALLARCHLIB=${d_build}$(archlib)
PERLVERSION=`$(PERL) -e 'printf("%.3f", $$])'`

#

build:
	${checkdir}
	-${MAKE} mostyclean
	${MAKE} shared CFLAGS="-O2 -fPIC -fomit-frame-pointer"
	${MAKE} perl-lib
	touch build

.PHONY: clean 
clean:	
	${checkdir}
	-rm -f out build build-* _SRCDIR_
	-${MAKE} distclean
	${update_standards_version} debian/control
	-rm -f `find . -name "*~"`
	-rm -rf debian/tmp `find debian/* -type d ! -name CVS`
	-rm -f debian/*substvars debian/files* core


binary-indep:	checkroot build
	${checkdir}
# There are no architecture-independent files to be uploaded
# generated by this package. If there were any they would be
# made here.

binary-run:	checkroot build
	${checkdir}
	-rm -rf ${d_build}
	#
	# need to create dirs by hand
	${install_dir}	${d_dirs} 
	#
	# ==== DEBIAN control files ====
	cd debian && ${install_DEBIAN_scripts}
	# shlibs dependency
	echo -e "${libname}\t${version_major}\t${package}" \
		> ${d_deb}/shlibs
	#
	# ==== make install ====
	${MAKE} install_run basedir=${d_usr}
	# move libs to /lib
	mv ${d_ulib}/* ${d_lib}
	strip --strip-unneeded 	${d_lib}/${libname}.${version}.so	
	# ==== symlink for shared libs to work; must be after shlib!  ====
	ln -s ${libname}.${version}.so	${d_lib}/${libname}.so.${version_major}
	#
	# ==== docs ====
	# particular documents that must be present with exactly this name
	cd debian && ${install_data}	changelog copyright  ${d_doc}
	#
	# now compress only large documents
	cd ${d_doc} && ${compress_docs}
	#
	# ==== clean dirs ====
	-${clean_dirs}
	# ==== md5sums ====
	cd ${d_build} && ${install_md5sums}
	# ==== finds dependencies ====
	dpkg-shlibdeps ${d_lib}/*
	# ==== process control file ====
	dpkg-gencontrol -p${package}
	chown -R root.root ${d_build}
	chmod -R go=rX ${d_build}
	dpkg --build ${d_build} ..

binary-dev:	checkroot
	# now add static libs, include file and manpage
	${checkdir}
	-rm -rf ${d_build}
	#
	# need to create dirs by hand
	${install_dir}	${d_dirs} 
	ln -s ${package} ${d_doc}-dev
	#
	# ==== DEBIAN control files ====
	prefix="dev" && cd debian && ${install_DEBIAN_scripts}
	#
	# ==== make install ====
	-${MAKE} mostyclean
	${MAKE} static CFLAGS="-g3 -O2"
	${MAKE} install_dev basedir=${d_usr}
	strip --strip-debug 	${d_ulib}/${libname}.a
	# ==== symlink for shared libs to work ====
	ln -s ${libname}.${version}.so	${d_lib}/${libname}.so
	#
	# ==== manpages ====
	${MAKE} install_doc basedir=${d_usr}
	gzip -r9 ${d_man}
	#
	# ==== clean dirs ====
	-${clean_dirs}
	# ==== md5sums ====
	cd ${d_build} && ${install_md5sums}
	# ==== process control file ====
	dpkg-gencontrol -p${package}-dev
	chown -R root.root ${d_build}
	chmod -R go=rX ${d_build}
	dpkg --build ${d_build} ..

binary-dbg:	checkroot
	# now add static libs with debug and profiling enabled
	${checkdir}
	-rm -rf ${d_build}
	#
	# need to create dirs by hand
	${install_dir}	${d_dirs}
	ln -s ${package} ${d_doc}-dbg
	#
	# ==== DEBIAN control files ====
	prefix="dbg" && cd debian && ${install_DEBIAN_scripts}
	#
	# ==== make install ====
	-${MAKE} mostyclean
	${MAKE} shared CFLAGS="-g3 -O2 -fPIC -DDEBUG" create_debug_lib=1
	${MAKE} install_debug basedir=${d_usr}
	-${MAKE} mostyclean
	${MAKE} shared CFLAGS="-g3 -pg -fPIC"
	${MAKE} install_profile basedir=${d_usr}
	#
	# ==== sources ====
	${install_sources}
	#
	# ==== docs ====
	cd debian && ${install_data}	README.debug	${d_doc}
	# now compress only large documents
	cd ${d_doc} && ${compress_docs}
	#
	# ==== clean dirs ====
	-${clean_dirs}
	# ==== md5sums ====
	cd ${d_build} && ${install_md5sums}
	# ==== process control file ====
	dpkg-gencontrol -p${package}-dbg
	chown -R root.root ${d_build}
	chmod -R go=rX ${d_build}
	dpkg --build ${d_build} ..

binary-perl:	checkroot build
	${checkdir}
	-rm -rf ${d_build}
	#
	# need to create dirs by hand
	${install_dir}	${d_dirs} ${d_doc}-perl ${d_man}/man3
	#
	# ==== docs ====
	# particular documents that must be present with exactly this name
	cd debian && ${install_data}	copyright changelog ${d_doc}-perl
	#
	# now compress only large documents
	cd ${d_doc}-perl && ${compress_docs}
	#
	# ==== make install ====
	cd LockDev && $(MAKE) pure_install $(config)
	-find ${d_build} -type f -name .packlist | xargs rm -f
	echo "perl:Depends=perl-$(PERLVERSION)" >>debian/substvars
	strip --strip-unneeded `find ${d_build} -name '*.so'`
	gzip -r9 ${d_man}
	#
	# ==== DEBIAN control files ====
	prefix="perl" && cd debian && ${install_DEBIAN_scripts}
	#
	# ==== clean dirs ====
	-${clean_dirs}
	# ==== md5sums ====
	cd ${d_build} && ${install_md5sums}
	# ==== process control file ====
	dpkg-gencontrol -p${package}-perl
	chown -R root.root ${d_build}
	chmod -R u=rwX,go=rX ${d_build}
	dpkg --build ${d_build} ..


binary-arch:	binary-run binary-dev binary-dbg binary-perl


.PHONY: binary binary-indep binary-arch binary-run binary-dev 
binary:		binary-indep binary-arch

.PHONY: checkroot 
checkroot:
	test root = "`whoami`"

## lockdev 1.0.1

=== Makefile ===
--- 
+++ 
@@ -1,8 +1,7 @@
-# this include do nothing if not run as a sub-make of debian/rules
--include debian/policy
-
+-include Rules.mk
 
 libname	= liblockdev
+pkgname = lockdev
 
 objs	= src/lockdev.o
 
@@ -38,8 +37,8 @@
 
 
 perl-lib:	static
-	cd LockDev && perl Makefile.PL INSTALLDIRS=perl
-	cd LockDev && make
+	cd LockDev && perl Makefile.PL INSTALLDIRS=vendor
+	cd LockDev && make OPTIMIZE="-O2 -g -Wall"
 	cd LockDev && make test
 
 .PHONY: install install_dev install_dbg install_doc install_run 
@@ -85,12 +84,7 @@
 
 distclean:	mostyclean perl-clean
 
-.PHONY: distribute debian tarball
-distribute:	debian tarball
-debian:
-	dpkg-buildpackage -rfakeroot 2>&1 | tee ../log.${VER}
-tarball:
-	${MAKE} -f debian/rules clean
-	cd .. 	&& tar -cvf - ${libname}-${VER} | gzip -9c > ${libname}_${VER}.tgz
-
-
+.PHONY: distribute dist tarball
+dist distribute:	tarball
+tarball: distclean
+	cd .. 	&& tar -cvf - ${pkgname}-${VER} --exclude='${pkgname}-${VER}/debian' | gzip -9c > ${pkgname}_${VER}.tgz

## lockdev 1.0.3

=== Makefile ===
--- 
+++ 
@@ -4,6 +4,7 @@
 pkgname = lockdev
 
 objs	= src/lockdev.o
+shobjs	= src/lockdev.z
 
 
 VER	= $(shell expr `pwd` : '.*-\([0-9.]*\)')
@@ -32,8 +33,11 @@
 static ${static}:       ${objs}
 	$(AR) $(ARFLAGS) ${static} $^
 
-shared ${shared}:	${objs}
+shared ${shared}:	${shobjs}
 	${CC} ${LCFLAGS} -shared -Wl,-soname,${soname} $^ -lc -o ${shared}
+
+src/lockdev.z: src/lockdev.c
+	${CC} ${CFLAGS} -c -fPIC -o $@ $?
 
 
 perl-lib:	static
@@ -77,6 +81,7 @@
 clean:
 	-find . -name '*~' | xargs --no-run-if-empty  rm -f 
 	-find . -name '*.o' | xargs --no-run-if-empty  rm -f 
+	-find . -name '*.z' | xargs --no-run-if-empty  rm -f 
 
 mostyclean:	clean
 	-rm -f *.a *.so *.so.*
@@ -87,4 +92,4 @@
 .PHONY: distribute dist tarball
 dist distribute:	tarball
 tarball: distclean
-	cd .. 	&& tar -cvf - ${pkgname}-${VER} --exclude='${pkgname}-${VER}/debian' | gzip -9c > ${pkgname}_${VER}.tgz
+	cd .. 	&& tar -cvf - ${pkgname}-${VER} | gzip -9c > ${pkgname}_${VER}.tgz
